Release Notes

see http://wiki.contextgarden.net/Release_Notes

Context 2011.05.18

The split between mkii and mkiv is now complete, the two versions no longer share any code. This is nice, but it also makes creating release notes a bit of a pointless exercise because numerous files have been renamed and code has been reshuffled.

Instead of going into details we just mention a couple of changes that were most noticeable in the diffs:

    ConTeXt now assumes luatex version 0.70.1.
    new mplib extension code (no longer a dual model using special colors and scripts)
    bitmap inclusion in MP code
    scalable colors in MP code as well as colors applied to textext() pictures
    image masks in MP code and \externalfigure
    spotcolor shading
    better integrated logging in lua, selective enable/disable, coupled to interface languages
    cleaned up resolver code, removal of some arcane web2c issues, a move towards URL-based file access
    pdf backend code cleaned up and moved to mkvi
    widgets cleaned up and rewritten (fields, attachments, comment, etc.)
    improved color profile support (plus PDF/X)
    intermediate colors (also needed for tikz)
    messages etc. are now defined in lua
    patterns are now stored in lua files
    relocatable tex tree (+cache)
    all kind of optimizations and cleanup of lua code
    more extensive cld support, cleanup of support modules (side effect of documentation)
    more efficient access to data tables
    cleanup of lpath (XML) parser code
    more efficient OTF data management (caching as well as in memory)
    better split between generic and context font code (so that we can more easily add features without interference with other macro packages)
    first version of epdf support
    new verbatim pretty print model plus cleanup of verbatim (lua) code, including nested parsers
    new catcode policy for ^, &, _ etc
    support for remapping of fonts (especially non-standard fonts like dingbats)
    more math and character definitions moved from tex files to lua
    cleaned up conversion code
    split between functions used at the lua end and derived ones used at the tex end (commands namespace)
    more extensive sorting methods using chained character properties (like shape, decomposition, script specifics)
    more access to status information in lua (modes, constants, conditionals etc)
    extended virtual font support
    more font goodies
    arabic paragraph optimizer (pending public version of Idris' Husayni font)
    labeltexts partially managed at the lua end (data tables)
    support for mkvi encoded files
    rewritten rule and color support in tabulate and table
    some cleanup of arrange related code
    cleaned up properties code
    additions to tagged PDF, improvements to XML export, experimental XHTML (+CSS) export, prelude to ePub support
    better support for the korean language
    improved automatic generation of random thesis code including cross references, citations and bibliographic references (for Mojca)
    more control over bookmarks
    rewritten mark (header, footer etc. related) code
    extended (but still experimental) rewrite of grid snapping
    extensions and clean-up of notes (more to follow)
    stripped down TaBle, removal of non-context features and replacement by more context friendly variants
    upgraded typescripts (to new font releases)
    automatic (base/node) mode detection of OpenType fonts 

For sure we forgot things.


Context 2010.07.30

New MkIV features:

    Tagged pdf generation.
    Experimental support for keeping links in included pdfs \externalfigure[file.pdf][page=1,interaction=yes]
    Hyphenation support is now processed with the help of lang-xx.lua files
    texmfcnf.lua (see the example contextcnf.lua) now completely replaces texmf.cnf (and has an internal structure)
    mtxrun has taken over the role of luatools (which is now a stub for mtxrun --script base and will eventually go away)
    TEXMFCACHE can now consist of multiple paths (one writable followed by any number of read-only paths)
    Support for the biolinum, stix, and xits fonts added, as well updated typescripts for iwona. 

Context 2010.05.24

This current fixes a small number of bugs in 2010.05.21, just in time for TeX Live 2010.

It also adds support for the latest version of antykwa-poltawskiego.


Context 2010.05.21

This current fixes a number of bugs in 2010.05.08.


Context 2010.05.08

    Many of the stubs for the ruby tools have gone away. If you want one of the old command names back, just create a link from mtxrun to the required name, e.g. copy mtxrun.exe to mptopdf.exe on windows. Eventually all perl and ruby scripts will be gone. Most functionality is already provided by lua variants.
    The hyphenation patterns for German, German (old), Hungarian and Spanish have been updated from the tex-hyphen project.
    New versions of the ancientgreek, letter, and simplefont modules are included.
    New modules: barcodes (mkiv only) and punk
    Support for shockwave flash has been updated (mkiv only). The backend code has been rewritten and currently only pdf is supported.
    The split between mkii and mkiv is getting more complete. Only a few mkii bug fixes have taken place.
    Typescripts are now split completely and no definitions are shared; loading of a mkio/mkiv file takes precedence over a tex file. 


Context 2009.11.26

     * The context command now supports --autopdf
     * Mark IV now has a new method for font selection in addition to
       name: and file:, called spec:. This uses heuristics to find a font
       based on the requested properties, for example: times-normal-italic
     * Mark IV now supports line notes and proper \formulanumbers
     * and a bunch of bugfixes, of course 

Context 2009.10.27

This release fixes a fairly large number of bugs and oversights in mkiv, 
and few in mkii.

Context 2009.08.19

This is the context version on TeXLive 2009.

Note TeXLive 2009 ships with a broken MkIV, because the luatex on TeXLive
is too old. Hans and I apologise for that, but it was just not feasible to
include a newer luatex. Once TeXLive is released, we will write down a
recipe to upgrade its luatex binary.

This is the first actually documented release for 2009 after a very long 
time of no release (and no release notes). The reason for that is that
ConTeXt is now split quite rigurously into source files for mkii and source
files for mkiv. Also, many of the core functions in context mkiv have been
rewritten to make extensive use of lua. Unfortunately, this means that there
is a massive amount of changes, and there is just no way I can create proper
release notes. Just follow the link for a (long) list of new, old, and
renamed source files.

Context 2008.10.31

New features:

    * A Persian interface (format)
    * The whole multilingual subsystem is rewritten and is now generated
      from a single lua database table. Note: external modules that define
      or set system constants and system variables will need updating.
    * New versions of the greek, vim and bib modules
    * More files have been split into mkii+mkiv parts
    * The old, dvipdfm style font mapfiles have been removed because newer
      versions of (x)dvipdfmx support the pdftex-style map format
    * mkiv now has support for 'special' features like knockout vs overprint
      and spot colors via attributes 

Bugs fixed:

    * lots of smaller bugs fixed, especially in the MPlib handling in mkiv,
      but many more small ones 

Context 2008.08.05

New feature:

    * mtx-fonts now supports displaying feature information for OTF fonts 

Bugs fixed:

    * a number of files were accidentally missing from the Context 2008.08.04
      release
    * Hyphenation patterns for bokmal and nynorsk were broken in
      Context 2008.08.04
    * \Word now works ok in MKIV 

Context 2008.08.04

New features:

    * MKIV now works best with luatex 0.29.0
    * Integrated support for 'arabic' languages and number conversions
    * New hyphenation patterns from the tex-hyphen project, including support
      for the new languages Nynorsk (nn), Bulgarian (bg), Basque (eu), and
      Ukranian (il). The identifiers of Czech (cz -> cs), UK English (uk -> gb)
      and US English (en -> us) have changed.
    * New third-party modules in cont-ext.zip: Account, Greek, and Letter
    * new mtxrun scipts: grep, mptopdf, patterns
    * New included module: calcmath (MKIV only)
    * Typescripts for Herman Zapf's fonts in OTF format are now provided
    * the mtxrun script 'context' is extended to be more like 'texexec'
    * the mtxrun script 'convert' now supports a requested quality switch
    * the mtxrun script 'server' is extended to support 'cgi' lua 

Bugs fixed:

    * Fix nasty font warnings in XeTeX
    * Lots of small bugs. Please follow the link to the details page. 

Context 2008.05.21

    * MKIV now has support for running without any environment variables set
      (still experimental, details are discussed on the dev-context mailing
      list)
    * Some of the internals of MathML support in MKIV have been reworked
    * A few small bugfixes 


Context 2008.05.13

    * small bugfixes for 2008.05.09
    * some corrections to the german interface messages 

Context 2008.05.09

    * A set of bugfixes relating to metapost labels in mkiv
    * A rewritten MathML parser for mkiv
    * Some math operator extensions for mkiv
    * Other bugfixes 

Context 2008.04.18

Small update to 2008.04.16:

    * a few more bugfixes
    * a bit of internal cleanup 

Context 2008.04.16

Small update to 2008.04.15:

    * mtxrun.lua now supports freebsd
    * 2008.04.15 introduced a stray character in m-chemic removed
    * the new MkIV font name resolver had an error
    * a few more dummies for mplib in MkIV
    * a fix for paragraph-shaped text in mplib (MkIV)
    * a fix for disappearing colors in mplib (MkIV) 

Context 2008.04.15

This release fixes a small set of bugs in MkIV:

    * some mplib conversion errors (part of those need a new, to-be-released
      luatex) and a few dummy macros
    * figures in subpaths were not found
    * see the separate page for more details 

And a few small extras for MkIV:

    * zwn and zwnj support
    * Environment variable MTX_FONTS_AUTOLOAD='yes' can be used to force
      automatic font database reloading on 'font not found' errors
    * A parser that reads fontconfig's fonts.conf added (if it can be found)
    * Better xml statistics reporting 

As well as some internal changes:

    * a bunch of counter implementations changed from macros to primitives.
      if you have styles that redefine core macros, they could be broken
      by this
    * the experimental reserved object numbers patch from 2008.04.10 is
      reverted, didn't work out. 

Context 2008.04.10

One big news item:

    * MkIV now uses the embedded MPlib in the latest luatex release.
      No more external MP calls, resulting in a massive speedup 

Also a bunch of bugfixes from the mailing list, and some small speedups

Context 2008.03.24

Fixes some more bugs in 2008.03.10

Context 2008.03.11

    * Fixes a few bugs in 2008.03.10

Context 2008.03.10

This is a feature release. Main news:

    * Image inclusion in mkiv now uses lua
    * Better support for zips and zipped xml files
    * And lots of bugfixes 

Context 2008.01.28

    * some small extensions to opentype support
    * fix a glitch in luatools that broke format generation in the
      'official' luatex beta
    * brings locating of processed files in mkiv in line with mkii 

Context 2008.01.26

    * bugfixes in contextual lookups and kerning handling in opentype
      (mkiv)
    * many macros that used \to for delimited arguments reimplemented
      without the need for \to
    * new command \setupmathematics, for global math setup 

Context 2008.01.16

    * New feature compose=yes will add missing composed chars as virtual
      glyphs 

 \definefontfeature[superdefault][default][compose=yes]

    * Some math bugfixes in mkiv
    * A few corrections to font synonyms 

Context 2008.01.11

This release fixes:

    * handling of truetype disguised as opentype and vice versa 

This release adds:

    * a prelude to math definitions for mkiv
    * a cache=no option for \setupfloats, i.e. direct flushing
    * support for new lm naming scheme + fallback 

Context 2007.12.17

   Many small optimizations, especially in the MkIV font code and the
   table processing

Context 2007.12.07

   This release only has a bit of speed gain at building XeTeX formats.

Context 2007.12.06

   This release simply fixes a few bugs in [42]Context 2007.12.05

Context 2007.12.05

   This release is mostly to sync MkIV with the new luatex beta 0.20.0:
     * line numbering is reimplemented to make use of the ability to
       process node lists, making it much more robust
     * lots of lua code speedups, partially make possible by the new beta
     * language support is reimplemented in lua and now uses dynamic
       loading of patterns/exceptions at runtime
     * the lua xml interface is expanded some more

   but there are some other (both MkII and MkIV) items as well:
     * Captions now support \setupcaptions[number=none]
     * It is now possible to control the alignment of the itemization
       symbol
     * \startblockquote ... \stopblockquote can be used if you don't want
       explicit quote markers
     * Better support for the use of PK bitmap fonts in metapost graphics
     * Previosuly, there was a problem with the use of LatinModern for
       math in unusual bodyfont sizes
     * lots of smaller bugs fixed

Context 2007.09.28

     * A rewritten XML parser for mkiv
     * XML path expressions for mkiv
     * Fixed and improved support for XeTeX fonts
     * The file extension and method for included files is now always
       lowercased
     * other small bugfixes

Context 2007.09.10

     * MathML and CALS tables for mkiv
     * mkiv font handling improvements
     * bugfixes

Context 2007.08.20

     * Fix some font issues in mkiv
     * Some smaller common bugfixes

Context 2007.08.09

     * Another set of bugfixes for Mark IV

Context 2007.08.08

     * A set of bugfixes for Mark IV

Context 2007.08.07

     * The [57]Mark IV release
     * a few small bugfixes

Context 2007.07.25

     * improved support for math over- ander underarrows
     * a few small bugfixes

Context 2007.07.24

     * infrastructure preparations for MkIV
     * support for 'reverse' in itemizes
     * various math fixes and extensions, including an improved
       \startsubstack
     * support for ending symbols and optional titles in description
       environments
     * fixed XeTeX font support (hopefully)
     * for various other small bugfixes and small extensions, see the
       detailed page

Context 2007.04.17

     * mptopdf and texexec (once again) support the handling of LaTeX
       files
     * allow blocking of installed programs for texutil
     * fix the handling of external graphics in xetex
     * various low-level fixes and extensiosn for multicolumn handling
     * bugfix for disappearing footnotes
     * support for TeX-Gyre Hermes
     * for various other small bugfixes, see the detailed page

Context 2007.03.22

     * ctxtools --updatecontext now supports a --proxy switch
     * and a few small bugfixes

Context 2007.03.19

     * Aditya's 'mathsets' modules in included in cont-ext.zip
     * The use of \setuphead[][numberwidth=...]
     * Named font styles can now also be 'sans' or 'sansbold'
     * The old marvosym metric file is included, fixing the 'MarvoSym'
       symbols and '\texteuro' bugs
     * Quoting of font files is changed so that hopefully XeTeX bare
       fontfiles are OK now.
     * For some other small changes, see the details page

Context 2007.02.21

   Bugfixes:
     * Handling of figure paths extended (cache support)
     * Corrected truetype font file for lmtypewriter10-regular (for use in
       X11)

Context 2007.02.20

   Bugfixes:
     * Quite a few (mostly very small) fixes

Context 2007.01.23

   Bugfixes:
     * A problem with spurious lines in metapost figures is removed
     * Creating XeTeX formats was broken in 2007.01.18

   New:
     * Gnuplot module (m-gnuplot.tex) removed from the core distro. This
       file is superceded by the third-party module

Context 2007.01.18

   Bugfixes:
     * corrected XeTeX commandline

   New:
     * The vim module is now included in [76]cont-ext.zip
     * Switch to latin modern math fonts. If this gives you trouble, you
       have to update your latin modern font package, see [77]CTAN

Context 2007.01.12

   Bugfixes:
     * the error code returns for texmfstart were reversed

   New:
     * Complete switch to pdftex 1.40. pdftex 1.30 is no longer supported!

Context 2007.01.10

   New:
     * texmstart, texexec and texsync support return codes now

Context 2007.01.09

   Bugfixes:
     * math display error
     * unicode map file loading error in non-pdftex 1.40

   New:
     * support for TeXGyreSchola fonts
     * --draft option for texexec (needs pdftex 1.40)
     * --passon added to texexec
     * extend the adobe euro font mapfile so it can be used by dvips

Context 2007.01.02

   Bugfixes:
     * re-enable norwegian hyphenation patterns
     * footnote referencing fix

   New:
     * Use the low-level support for ToUnicode mapping in pdftex 1.40, if
       possible

